multiusercalendarmodule.prototype = new ListModule;
multiusercalendarmodule.prototype.constructor = multiusercalendarmodule;
multiusercalendarmodule.superclass = ListModule.prototype;


function multiusercalendarmodule(id, element, title, data)
{
	if(arguments.length > 0) {
		this.init(id, element, title, data);
	}
	
}

multiusercalendarmodule.prototype.init = function(id, element, title, data)
{
	this.element = element;
	if(!data){
		var data = new Array();
	}
	data["has_no_menu"] = false;
	this.groupIDCounter = 1;

	this.setTitle(_("Multi User Calendar"), NBSP, true);
	document.title = _("Multi User Calendar") +" - "+ _("Zarafa Webaccess");

	this.numOfDaysInViewport = webclient.settings.get("calendar/mucalendar/zoomlevel", 3);
	this.numOfDays = webclient.settings.get("calendar/mucalendar/numofdaysloaded", 5);

	// timeToZero will return the timestamp of the start of the day
	var startDate = timeToZero(( (new Date()).getStartDateOfWeek().getTime()/1000 ));
	this.viewedDays = this.calcViewedDays(startDate, this.numOfDays);

	this.groups = Array();

	this.startupUsers = webclient.settings.get("calendar/mucalendar/startupusers", "").split(";");

	if(webclient.hierarchy) {
		var folder = dhtml.getElementById(webclient.hierarchy.selectedFolder);
		if(folder) {
			var folderIcon = folder.getElementsByTagName("div")[1];
			var folderName = folderIcon.getElementsByTagName("span")[0];
			folderName.className = "folder_title";
		}
	}

	multiusercalendarmodule.superclass.init.call(this, id, element, title, data);

//	if (!webclient.datepicker){
//		var data2 = new Object();
//		webclient.datepicker = webclient.loadModule("datepickerlist", _("Date picker"), "left", data2, BOX_LAYOUT, INSERT_ELEMENT_AT_TOP);
//	}

	// Set Menu items
	this.menuItems.push(webclient.menu.createMenuItem("seperator", ""));
	this.menuItems.push(webclient.menu.createMenuItem("prevperiod", _("Previous Period"), _("Load previous period"), eventMultiUserCalendarViewClickPrevPeriod));
	this.menuItems.push(webclient.menu.createMenuItem("prevday", _("Previous Day"), _("Load previous day"), eventMultiUserCalendarViewClickPrevDay));
	this.menuItems.push(webclient.menu.createMenuItem("nextday ", _("Next Day"), _(""), eventMultiUserCalendarViewClickNextDay));
	this.menuItems.push(webclient.menu.createMenuItem("nextperiod", _("Next Period"), _("Forward"), eventMultiUserCalendarViewClickNextPeriod));
	this.menuItems.push(webclient.menu.createMenuItem("seperator", ""));
	this.menuItems.push(webclient.menu.createMenuItem("loadgroup", _("Load Group")+"...", _("Load group"), function(){
		webclient.openModalDialog(-1, 'usergroup', DIALOG_URL+'task=usergroup_modal', 600,450, mucalendarDialog_loadgroups_addCallBack, {moduleID:this.id});
	}));
	this.menuItems.push(webclient.menu.createMenuItem("adduser", _("Add User")+"...", _("Add new user"), function(){
		var windowData = new Object();
		windowData["hide_users"] = ["contact"];
		windowData["hide_groups"] = ["dynamic", "normal", "everyone", "security"];
		windowData["hide_companies"] = true;

		webclient.openModalDialog(-1, 'addressbook', DIALOG_URL+'&type=username&source=gab&task=addressbook_modal&storeid=' + webclient.hierarchy.defaultstore["id"], 800, 500, mucalendarDialog_adduser_addCallBack, {moduleID: this.id}, windowData);
	}));
	this.menuItems.push(webclient.menu.createMenuItem("removeuser", _("Remove user"), _("Remove user"), eventMultiUserCalendarViewRemoveUsers));
	// Build menu and put it on the screen
	webclient.menu.buildTopMenu(this.id, "appointment", this.menuItems, eventListNewMessage);
	webclient.menu.showMenu();


	var items = new Array();
	items.push(webclient.menu.createMenuItem("open", _("Open"), false, eventAppointmentListContextMenuOpenMessage));
	items.push(webclient.menu.createMenuItem("print", _("Print"), false, eventListContextMenuPrintMessage));
	items.push(webclient.menu.createMenuItem("seperator", ""));
	items.push(webclient.menu.createMenuItem("categories", _("Categories"), false, eventListContextMenuCategoriesMessage));
	items.push(webclient.menu.createMenuItem("seperator", ""));
	items.push(webclient.menu.createMenuItem("delete", _("Delete"), false, eventAppointmentListContextMenuDeleteMessage));
	this.contextmenu = items;

	/**
	 * Adding storeID to multiusercalendar to fix the createNewItem. This is not
	 * supplied by the server, so we have to take it from the hierarchymodule. 
	 * This also means that is has to happen AFTER the call to the super class, 
	 * otherwise it will be overwritten with the boolean value false.
	 */
	if(webclient.hierarchy && webclient.hierarchy.defaultstore && webclient.hierarchy.defaultstore.id){
		this.storeid = webclient.hierarchy.defaultstore.id;
	}

	this.keys["muc"] = KEYS["muc"];

	this.initializeView();
}

multiusercalendarmodule.prototype.initializeView = function(view)
{
	if(!this.contentElement){
		this.contentElement = dhtml.addElement(this.element, "div", false, "mucalendar_content["+this.id+"]");
	}

	this.viewController.initView(this.id, "multiusercalendar", this.contentElement, this.events, {numOfDays: this.numOfDays, numOfDaysInViewport: this.numOfDaysInViewport, vieweddays: this.viewedDays});

	//webclient.xmlrequest.addData(this, "getgroups", {});
	//webclient.xmlrequest.sendRequest();
	if(this.groups.length > 0){
		for(var i=0;i<this.groups.length;i++){
			this.viewController.addGroup({
				"groupID": this.groups[i].groupID, 
				"name":    this.groups[i].display_name, 
				"access":  this.groups[i].access, 
				"storeid": this.groups[i].storeid, 
				"folderentryid": this.groups[i].folderentryid
			});
			this.groups[i].setTimePeriod(this.viewedDays);
			this.groups[i].list();
		}
	}else{
		var userData = new Array();
		for(var i in this.startupUsers){
			userData.push({
				entryid: "",
				username: this.startupUsers[i]
			});
		}
		this.getUsers(userData);
	}

	webclient.inputmanager.addObject(this, this.element);
	webclient.inputmanager.bindKeyControlEvent(this, this.keys["refresh"], "keyup", eventListKeyCtrlRefreshFolder);
}

multiusercalendarmodule.prototype.getGroup = function(groupID){
	for(var i=0;i<this.groups.length;i++){
		if(this.groups[i].groupID == groupID){
			return this.groups[i];
		}
	}
	return false;
}

multiusercalendarmodule.prototype.addGroup = function(groupEntryID){
	webclient.xmlrequest.addData(this, "getgroupusers", {group_entry_id: groupEntryID});
	setTimeout(function(){
		webclient.xmlrequest.sendRequest();
	}, 0);
	this.removeAllGroups();
}

multiusercalendarmodule.prototype.getUsers = function(userData){
	var users = new Array();

	for(var i=0;i<userData.length;i++){
		if(userData[i].username){
			users.push({user: {user_entry_id: userData[i].entryid, username: userData[i].username} });
		}
	}

	if(users.length > 0){
		webclient.xmlrequest.addData(this, "getusers", {users: users});
	}

	setTimeout(function(){
		webclient.xmlrequest.sendRequest();
	}, 0);
}

multiusercalendarmodule.prototype.addUser = function(groupData){
	// Check if the user has already been added
	var adduser = true;
	if(groupData.storeid != null){
		for(var i=0;i<this.groups.length;i++){
			if(this.groups[i].getStoreID() == groupData.storeid){
				adduser = false;
			}
		}
	}

	if(adduser){
		// Load module
		var module = webclient.dispatcher.loadModule("multiusercalendarappointmentlistmodule");
		webclient.addModule(module);

		if(module) {
			// Add module
			var moduleID = webclient.addModule(module);
			var data = {
				mucalendarParent: this, 
				userentryid: groupData.userentryid,
				storeid: groupData.storeid,
				folderentryid: groupData.folderentryid,
				/**
				 * The entryid has to be named as such because is used to check whether updated 
				 * items are meant for the multiusercalendarappointmentlistmodule module by checking
				 * it against their parent entryid.
				 */
				entryid: groupData.folderentryid,
				display_name: groupData.display_name,
				username: groupData.username,
				email_address: groupData.username,
				access: groupData.access,
				groupID: this.groupIDCounter++
			};
			// Initialize module
			module.init(moduleID, this.contentElement, null, data);
			module.setTimePeriod(this.viewedDays);
			module.list();

			this.viewController.addGroup({
				"groupID":data.groupID,
				"name":groupData.display_name,
				"access": groupData.access,
				"storeid": groupData.storeid, 
				"folderentryid": groupData.folderentryid,
				"username": data.username
			});

			this.groups.push(module);
		}

		return module;
	}else{
//TODO: notify user of failed attempt to add user
		return false;
	}
}

multiusercalendarmodule.prototype.execute = function(type, action) {
    if(type == "error") {
        var message = dhtml.getXMLValue(dhtml.getXMLNode(action, "error"), "message");
        alert(message);
    }
    else {
        multiusercalendarmodule.superclass.execute.call(this, type, action);
    }
}

multiusercalendarmodule.prototype.removeAllGroups = function(){
	while(this.groups.length){
		var group = this.groups.shift();
		if(!this.groups.length){	// Last item
			this.viewController.deleteGroup(group.groupID, {noresize: false});
		}else{
			this.viewController.deleteGroup(group.groupID, {noresize: true});
		}
		// Delete group module from webclient
		webclient.deleteModule(group);
	}
}
multiusercalendarmodule.prototype.deleteGroup = function(groupID){
	for(var i=0;i<this.groups.length;i++){
		if(this.groups[i].groupID == groupID){
			var group = this.groups.splice(i, 1);
			this.viewController.deleteGroup(group[0].groupID);
			// Delete group module from webclient
			webclient.deleteModule(group);
		}
	}
	this.setStartupUsersSetting();
}

// Received from mucalendarAppointmentListView to pass on to mucalendarListModule
multiusercalendarmodule.prototype.executeAppView = function(items, properties, action, groupID){
	return this.viewController.addItems(items, properties, action, groupID);
}

multiusercalendarmodule.prototype.updateItemAppView = function(items, properties, action, groupID){
	return this.viewController.updateItem(items, properties, action, groupID);
}

multiusercalendarmodule.prototype.addItemAppView = function(items, properties, action, groupID){
	/**
	 * The item is sent as an array to make sure the positionAllAttendeesBarItems and vPositionItems
	 * methods are called from the view itself.
	 */
	return this.viewController.addItems(Array(items), properties, action, groupID);
}

multiusercalendarmodule.prototype.deleteItemsAppView = function(items, groupID){
	return this.viewController.deleteItems(items, groupID);
}


// Receives listed items from server module multiusercalendarmodule
multiusercalendarmodule.prototype.messageList = function(action){
	var items = action.getElementsByTagName("item");
	for(var i=0;i<items.length;i++){
		var item = items[i];

		if(dhtml.getXMLValue(item, "type") == "usergroup"){
			var data = {
				groupEntryID: dhtml.getXMLValue(item, "entryid"),
				display_name: dhtml.getXMLValue(item, "subject")
			}
		}else{
			var data = {
				userentryid: dhtml.getXMLValue(item, "entryid"),
				display_name: dhtml.getXMLValue(item, "display_name"),
				storeid: dhtml.getXMLValue(item, "storeid"),
				folderentryid: dhtml.getXMLValue(item, "calentryid"),
				username: dhtml.getXMLValue(item, "username"),
				access: dhtml.getXMLValue(item, "access")
			}
			this.addUser(data);
		}
	}
	this.setStartupUsersSetting();
}

multiusercalendarmodule.prototype.setStartupUsersSetting = function(){
	var userlist = new Array();
	for(var i=0;i<this.groups.length;i++){
		userlist.push(this.groups[i].username);
	}
	webclient.settings.set("calendar/mucalendar/startupusers", userlist.join(";"));
	return userlist;
}

// Shift view time periods
multiusercalendarmodule.prototype.changeTimePeriod = function(type){
	var datepickerlistmodule = webclient.getModulesByName("datepickerlistmodule")[0];
	var timestamp = new Date(this.viewedDays[0]*1000);

	switch(type){
		case "prevperiod":
			timestamp.addDays(-this.viewedDays.length);
			break;
		case "prevday":
			timestamp.addDays(-1);
			break;
		case "nextday":
			timestamp.addDays(+1);
			break;
		case "nextperiod":
			timestamp.addDays(+this.viewedDays.length);
			break;
	}

	//datepickerlistmodule.changeMonth(timestamp.getMonth() + 1, timestamp.getFullYear(), true);
	//datepickerlistmodule.changeSelectedDate(timestamp.getTime(),true);

	this.viewedDays = this.calcViewedDays((timestamp.getTime()/1000), this.viewedDays.length);
	this.initializeView();
}


multiusercalendarmodule.prototype.calcViewedDays = function(startdate, numOfDays){
	var days = new Array();
	var date = new Date(startdate * 1000);
	days.push(date.getTime()/1000);
	// Start at 1, first is already added
	for(var i=1;i<numOfDays;i++){
		date.addDays(+1);
		days.push(date.getTime()/1000);
	}
	//days[(days.length-1)] = days[(days.length-1)] + 24*60*60;
	return days;
}


multiusercalendarmodule.prototype.destructor = function()
{
	while(this.groups.length){
		// Delete group module from webclient
		webclient.deleteModule(this.groups.shift());
	}
	multiusercalendarmodule.superclass.destructor(this);
}

multiusercalendarmodule.prototype.refresh = function()
{
	this.initializeView();
}